<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<title>DUNE Warm Interface Board: /home/dan/work/DUNE/dune-wib.firmware/trunk/src/register_map/register_map_bridge.vhd Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">DUNE Warm Interface Board
   </div>
   <div id="projectbrief">Firmware for the DUNE Warm Interface Board (WIB)</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.1 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="annotated.html"><span>Design&#160;Unit&#160;List</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Variables</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_3b0ea9aee423ce83e8b3c941e3b80d69.html">register_map</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">register_map_bridge.vhd</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="vhdlkeyword">library </span><span class="keywordflow">ieee</span>;</div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_1164.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="vhdlkeyword">use </span>ieee.numeric_std.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="vhdlkeyword">use </span>ieee.std_logic_misc.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="vhdlkeyword">use </span>work.<a class="code" href="classtypes.html">types</a>.<span class="vhdlkeyword">all</span>;</div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;</div>
<div class="line"><a name="l00007"></a><span class="lineno"><a class="code" href="classregister__map__bridge.html">    7</a></span>&#160;<span class="keywordflow">entity </span><a class="code" href="classregister__map__bridge.html">register_map_bridge</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;</div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;  <span class="vhdlkeyword">generic</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;    <span class="vhdlchar">CLOCK_DOMAINS</span> <span class="vhdlchar">:</span> <span class="comment">integer</span> <span class="vhdlchar">:=</span> <span class="vhdllogic"></span><span class="vhdllogic">2</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;  <span class="vhdlkeyword">port</span> <span class="vhdlchar">(</span></div>
<div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="vhdlchar">clk_reg_map</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="keyword">    -- <span class="vhdlkeyword">register</span> <span class="vhdlkeyword">map</span> signals (clk_reg_map)</span></div>
<div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;    <span class="vhdlchar">reset</span>       <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <span class="vhdlchar">WR_strobe</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="vhdlchar">RD_strobe</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    <span class="vhdlchar">WR_address</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    <span class="vhdlchar">RD_address</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="vhdlchar">data_in</span>     <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    <span class="vhdlchar">data_out</span>    <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="keyword">    --fifo signals (clk_domain(i))</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    <span class="vhdlchar">clk_domain</span>         <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    <span class="vhdlchar">clk_domain_locked</span>  <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">    -- <span class="vhdlkeyword">register</span> read interface (clk_domain(i))</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="vhdlchar">read_address_valid</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="vhdlchar">read_address_ack</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="vhdlchar">read_address</span>       <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">uint16_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    <span class="vhdlchar">read_data_wr</span>          <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    <span class="vhdlchar">read_data</span>             <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="vhdlchar">uint36_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;<span class="keyword">    --register write interface (clk_domain(i))</span></div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    <span class="vhdlchar">write_addr_data_valid</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="vhdlchar">write_addr_data_ack</span>   <span class="vhdlchar">:</span> <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    <span class="vhdlchar">write_addr</span>            <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">uint16_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    <span class="vhdlchar">write_data</span>            <span class="vhdlchar">:</span> <span class="vhdlkeyword">out</span> <span class="vhdlchar">uint32_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span></div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">entity</span> <span class="vhdlchar">register_map_bridge</span>;</div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;</div>
<div class="line"><a name="l00042"></a><span class="lineno"><a class="code" href="classregister__map__bridge_1_1Behavioral.html">   42</a></span>&#160;<span class="vhdlkeyword">architecture</span> Behavioral <span class="vhdlkeyword">of</span> <a class="code" href="classregister__map__bridge.html">register_map_bridge</a> is</div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div>
<div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classIOREG__READ__ADDR__FIFO.html">IOREG_READ_ADDR_FIFO</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;      data    : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;      rdclk   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;      rdreq   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;      wrclk   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;      wrreq   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;      q       : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;      rdempty : <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>);</div>
<div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">IOREG_READ_ADDR_FIFO</span>;</div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classIOREG__READ__DATA__FIFO.html">IOREG_READ_DATA_FIFO</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;      aclr    : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span> := &#39;<span class="vhdllogic"></span><span class="vhdllogic">0</span>&#39;;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;      data    : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">35</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;      rdclk   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;      rdreq   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;      wrclk   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;      wrreq   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;      q       : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">35</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;      rdempty : <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>);</div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">IOREG_READ_DATA_FIFO</span>;</div>
<div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;  <span class="vhdlkeyword">component</span> <a class="code" href="classIOREG__WRITE__FIFO.html">IOREG_WRITE_FIFO</a> <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <span class="vhdlkeyword">port</span> (</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;      data    : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">47</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;      rdclk   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;      rdreq   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;      wrclk   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;      wrreq   : <span class="vhdlkeyword">in</span>  <span class="comment">std_logic</span>;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;      q       : <span class="vhdlkeyword">out</span> <span class="comment">std_logic_vector</span> (<span class="vhdllogic"></span><span class="vhdllogic">47</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span>);</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;      rdempty : <span class="vhdlkeyword">out</span> <span class="comment">std_logic</span>);</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">component</span> <span class="vhdlchar">IOREG_WRITE_FIFO</span>;</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;<span class="keyword">  -- signals</span><span class="keyword"></span></div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;  <span class="vhdlkeyword">type</span> <span class="vhdlchar">REG_STATE_t</span> <span class="vhdlkeyword">is</span> <span class="vhdlchar">(</span><span class="vhdlchar">REG_STATE_IDLE</span><span class="vhdlchar">,</span></div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;                       REG_STATE_READ_REQUEST,</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;                       REG_STATE_READ_WAIT,</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;                       REG_STATE_READ_RESET,</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;                       REG_STATE_READ_RESET_WAIT</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;                       <span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">REG_State</span> <span class="vhdlchar">:</span> <span class="vhdlchar">REG_STATE_t</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">REG_STATE_IDLE</span>;</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">clk_domain_enabled</span>         <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">clk_domain_enabled_buf</span>     <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_cycle_address_fifo_in</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">15</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>              <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_cycle_address_wr</span>      <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_cycle_data_fifo_out</span>   <span class="vhdlchar">:</span> <span class="vhdlchar">uint36_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>   <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_cycle_data_fifo_reset</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">write_cycle_addr_data_wr</span>   <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_cycle_data_ack</span>        <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_cycle_data_empty</span>      <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">write_cycle_addr_and_data</span>  <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">47</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>              <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_data_fifo_valid</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_data_fifo_found</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">read_address_fifo_empty</span> <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;<span class="keyword">--  <span class="vhdlkeyword">signal</span> read_cycle_data_empty          : <span class="comment">std_logic_vector</span>(CLOCK_DOMAINS-1 <span class="vhdlkeyword">downto</span> </span><span class="vhdllogic">0</span>) := (<span class="vhdlkeyword">others</span> =&gt; &#39;0&#39;);</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">write_fifo_empty</span>        <span class="vhdlchar">:</span> <span class="comment">std_logic_vector</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;  <span class="vhdlkeyword">signal</span> <span class="vhdlchar">write_addr_data</span>         <span class="vhdlchar">:</span> <span class="vhdlchar">uint48_array_t</span><span class="vhdlchar">(</span><span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>   <span class="vhdlchar">:=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;<span class="vhdlkeyword">begin </span><span class="keyword"> -- <span class="vhdlkeyword">architecture</span> Behavioral</span></div>
<div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="keyword">  -- Clock domain enable</span><span class="keyword"></span></div>
<div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;  domain_enable_control : <span class="vhdlkeyword">process</span> (clk_reg_map, reset) <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="vhdlkeyword">  begin </span><span class="keyword"> -- <span class="vhdlkeyword">process</span> domain_enable_control</span></div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <span class="vhdlkeyword">if</span> <span class="vhdlchar">reset</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">                 -- asynchronous reset (active high)</span></div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;      <span class="vhdlchar">clk_domain_enabled</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">clk_reg_map</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">event</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">clk_reg_map</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- rising clock edge</span><span class="keyword"></span></div>
<div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;<span class="keyword">      --enable a domain <span class="vhdlkeyword">if</span> it&#39;s clock <span class="vhdlkeyword">is</span> locked</span></div>
<div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;      <span class="vhdlchar">clk_domain_enabled_buf</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">clk_domain_locked</span>;</div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;      <span class="vhdlchar">clk_domain_enabled</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">clk_domain_enabled_buf</span>;</div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> <span class="vhdlchar">domain_enable_control</span>;</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;<span class="keyword">  -- UDP interface <span class="vhdlkeyword">to</span> <span class="vhdlkeyword">register</span> maps <span class="vhdlkeyword">in</span> different clock domains</span><span class="keyword"></span></div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;<span class="keyword">  -------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;  register_control : <span class="vhdlkeyword">process</span> (clk_reg_map, reset) <span class="vhdlkeyword">is</span></div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;<span class="vhdlkeyword">  begin </span><span class="keyword"> -- <span class="vhdlkeyword">process</span> register_control</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <span class="vhdlkeyword">if</span> <span class="vhdlchar">reset</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">                 -- asynchronous reset (active high)</span><span class="keyword"></span></div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;<span class="keyword">      -- turn <span class="vhdlkeyword">of</span> fifo reset request</span></div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;      <span class="vhdlchar">read_cycle_data_fifo_reset</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;      <span class="vhdlchar">read_cycle_data_ack</span>        <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;      <span class="vhdlchar">write_cycle_addr_data_wr</span>   <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;      <span class="vhdlchar">read_cycle_address_wr</span>      <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">clk_reg_map</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">event</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">clk_reg_map</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- rising clock edge</span><span class="keyword"></span></div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;<span class="keyword">      -- turn off fifo reset request</span></div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;      <span class="vhdlchar">read_cycle_data_fifo_reset</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;<span class="keyword">      --read/write strobe resets</span></div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;      <span class="vhdlchar">read_cycle_address_wr</span>      <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;      <span class="vhdlchar">read_cycle_data_ack</span>        <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;      <span class="vhdlchar">write_cycle_addr_data_wr</span>   <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">(</span><span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;<span class="keyword">      -- simplify debugging</span><span class="keyword"></span></div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;<span class="keyword">--      write_cycle_addr_and_data &lt;= (<span class="vhdlkeyword">others</span> =&gt; &#39;0&#39;);</span><span class="keyword"></span></div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;<span class="keyword">--      read_cycle_address_fifo_in &lt;= (<span class="vhdlkeyword">others</span> =&gt; &#39;0&#39;);</span></div>
<div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;<span class="keyword">      --State machine</span></div>
<div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;      <span class="vhdlkeyword">case</span> <span class="vhdlchar">REG_STATE</span> <span class="vhdlkeyword">is</span><span class="keyword"></span></div>
<div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="keyword">        -- <span class="vhdlkeyword">Register</span> IDLE (read has priority over write)</span><span class="keyword"></span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;<span class="keyword">        -------------------------------------------------------------------------        </span></div>
<div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">REG_STATE_IDLE</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span></div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">RD_strobe</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span></div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">and_reduce</span><span class="vhdlchar">(</span><span class="vhdlchar">read_cycle_data_empty</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword"></span></div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;<span class="keyword">              -- There are no pending reads</span></div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;              REG_STATE &lt;= REG_STATE_READ_REQUEST;</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;            <span class="vhdlkeyword">else</span><span class="keyword"></span></div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;<span class="keyword">              -- There <span class="vhdlkeyword">is</span> a pending read, so reset <span class="vhdlkeyword">and</span> <span class="vhdlkeyword">then</span> do our read</span><span class="keyword"></span></div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;<span class="keyword">              --clear read data fifos</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;              <span class="vhdlkeyword">for</span> <span class="vhdlchar">iCD</span> <span class="vhdlkeyword">in</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">to</span> <span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">loop</span></div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;                <span class="vhdlchar">read_cycle_data_ack</span><span class="vhdlchar">(</span><span class="vhdlchar">iCD</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlkeyword">not</span> <span class="vhdlchar">read_cycle_data_empty</span><span class="vhdlchar">(</span><span class="vhdlchar">iCD</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;              <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">loop</span>;<span class="keyword">  -- iCD</span></div>
<div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;<span class="keyword">              --wait <span class="vhdlkeyword">for</span> resets <span class="vhdlkeyword">to</span> finish</span></div>
<div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;              REG_STATE &lt;= REG_STATE_READ_RESET_WAIT;</div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;          <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">WR_strobe</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword"></span></div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;<span class="keyword">            --write the data <span class="vhdlkeyword">and</span> address <span class="vhdlkeyword">to</span> each enabled fifo</span></div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;            <span class="vhdlchar">write_cycle_addr_data_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">clk_domain_enabled</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;<span class="keyword">--            write_cycle_addr_and_data &lt;= WR_address &amp; data_in;</span><span class="keyword"></span></div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;<span class="keyword">            --we are done <span class="vhdlkeyword">in</span> this clock domain, go back <span class="vhdlkeyword">to</span> idle</span></div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;            REG_STATE                &lt;= REG_STATE_IDLE;<span class="keyword"></span></div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;<span class="keyword">          --write request        </span></div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;<span class="keyword">        -- Read fifo busy, do a reset</span><span class="keyword"></span></div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;<span class="keyword">        -------------------------------------------------------------------------        </span></div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">REG_STATE_READ_RESET_WAIT</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;<span class="keyword">          -- <span class="vhdlkeyword">wait</span> <span class="vhdlkeyword">for</span> <span class="vhdlkeyword">all</span> fifos <span class="vhdlkeyword">to</span> reset</span></div>
<div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">and_reduce</span><span class="vhdlchar">(</span><span class="vhdlchar">read_cycle_data_empty</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword"></span></div>
<div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;<span class="keyword">            -- we are ready <span class="vhdlkeyword">to</span> read now</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;            REG_STATE &lt;= REG_STATE_READ_REQUEST;</div>
<div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;          <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;            REG_STATE &lt;= REG_STATE_READ_RESET_WAIT;<span class="keyword"></span></div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;<span class="keyword">            --ack the readout <span class="vhdlkeyword">until</span> free</span></div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;            <span class="vhdlkeyword">for</span> <span class="vhdlchar">iCD</span> <span class="vhdlkeyword">in</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">to</span> <span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">loop</span></div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;              <span class="vhdlchar">read_cycle_data_ack</span><span class="vhdlchar">(</span><span class="vhdlchar">iCD</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlkeyword">not</span> <span class="vhdlchar">read_cycle_data_empty</span><span class="vhdlchar">(</span><span class="vhdlchar">iCD</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">loop</span>;<span class="keyword">  -- iCD</span></div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;<span class="keyword">        -------------------------------------------------------------------------</span><span class="keyword"></span></div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;<span class="keyword">        -- <span class="vhdlkeyword">Wait</span> <span class="vhdlkeyword">for</span> a fifo <span class="vhdlkeyword">to</span> respond <span class="vhdlkeyword">and</span> <span class="vhdlkeyword">return</span> the value</span><span class="keyword"></span></div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;<span class="keyword">        -- Since this setup allows <span class="vhdlkeyword">for</span> multiple responses from the same</span><span class="keyword"></span></div>
<div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;<span class="keyword">        -- address(different domains), we have a rule that we take the lowest</span><span class="keyword"></span></div>
<div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;<span class="keyword">        -- index <span class="vhdlkeyword">return</span>.</span><span class="keyword"></span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="keyword">        -------------------------------------------------------------------------        </span></div>
<div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">REG_STATE_READ_REQUEST</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;<span class="keyword">          -- write the address we want <span class="vhdlkeyword">to</span> read <span class="vhdlkeyword">to</span> the other clock domains</span></div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;          <span class="vhdlchar">read_cycle_address_wr</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">clk_domain_enabled</span>;<span class="keyword">  -- only activate</span><span class="keyword"></span></div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;<span class="keyword">                                                        -- enabled fifos</span><span class="keyword"></span></div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;<span class="keyword">--              read_cycle_address_fifo_in &lt;= RD_address; --delayed by atleast</span><span class="keyword"></span></div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;<span class="keyword">--                                                        --one clock from RD_strobe</span></div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;          REG_STATE             &lt;= REG_STATE_READ_WAIT;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlchar">REG_STATE_READ_WAIT</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span><span class="keyword"></span></div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;<span class="keyword">          --if and_reduce(read_data_fifo_valid) = &#39;1&#39; <span class="vhdlkeyword">then</span>          </span></div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;          <span class="vhdlkeyword">if</span> <span class="vhdlchar">or_reduce</span><span class="vhdlchar">(</span><span class="vhdlchar">clk_domain_enabled</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">read_cycle_data_empty</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword"></span></div>
<div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;<span class="keyword">            --All domain fifos have returned data (no enabled fifo <span class="vhdlkeyword">is</span> empty)</span></div>
<div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;            <span class="vhdlkeyword">if</span> <span class="vhdlchar">(</span><span class="vhdlchar">clk_domain_enabled</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">and</span> <span class="vhdlchar">(</span><span class="vhdlchar">read_data_fifo_found</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">1</span><span class="vhdlchar">&#39;</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">then</span><span class="keyword"></span></div>
<div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;<span class="keyword">              --The first clock domain has <span class="vhdlkeyword">to</span> be treated special <span class="vhdlkeyword">for</span> the later</span><span class="keyword"></span></div>
<div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;<span class="keyword">              --for <span class="vhdlkeyword">loop</span></span><span class="keyword"></span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="keyword">              --read the data</span></div>
<div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;              <span class="vhdlchar">data_out</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">read_cycle_data_fifo_out</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;            <span class="vhdlkeyword">elsif</span> <span class="vhdlchar">CLOCK_DOMAINS</span> <span class="vhdlchar">/=</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">then</span><span class="keyword">  -- The following logic requires more</span><span class="keyword"></span></div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;<span class="keyword">                                           -- than one clock domain</span></div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;              <span class="vhdlkeyword">for</span> <span class="vhdlchar">iClockDomain</span> <span class="vhdlkeyword">in</span> <span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">to</span> <span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">loop</span><span class="keyword"></span></div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;<span class="keyword">                -- Check <span class="vhdlkeyword">if</span> this clock domain&#39;s fifo has data <span class="vhdlkeyword">in</span> it,</span><span class="keyword"></span></div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;<span class="keyword">                -- but no clock domain fifo <span class="vhdlkeyword">with</span> a lower index does.</span></div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;                <span class="vhdlkeyword">if</span> <span class="vhdlchar">or_reduce</span><span class="vhdlchar">(</span><span class="vhdlchar">read_data_fifo_found</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span> <span class="vhdlkeyword">and</span></div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;                             <span class="vhdlchar">clk_domain_enabled</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span><span class="vhdlchar">)</span> <span class="vhdlchar">=</span> <span class="vhdlchar">&#39;</span><span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">&#39;</span> <span class="vhdlkeyword">then</span><span class="keyword"></span></div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;<span class="keyword">                  --read the data</span></div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;                  <span class="vhdlchar">data_out</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">read_cycle_data_fifo_out</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;                <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;              <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">loop</span>;<span class="keyword">  -- iClockDomain <span class="vhdlkeyword">in</span> </span><span class="vhdllogic">0</span> <span class="vhdlkeyword">to</span> CLOCK_DOMAINS-1 <span class="vhdlkeyword">loop</span></div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;            <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;<span class="keyword"></span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;<span class="keyword">            --mark <span class="vhdlkeyword">all</span> data as read (<span class="vhdlkeyword">if</span> domain <span class="vhdlkeyword">is</span> active)</span></div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;            <span class="vhdlchar">read_cycle_data_ack</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">clk_domain_enabled</span>;<span class="keyword">  --(<span class="vhdlkeyword">others</span> =&gt; &#39;1&#39;);</span></div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;            REG_STATE           &lt;= REG_STATE_IDLE;</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;          <span class="vhdlkeyword">else</span></div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            REG_STATE &lt;= REG_STATE_READ_WAIT;</div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;          <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        <span class="vhdlkeyword">when</span> <span class="vhdlkeyword">others</span> <span class="vhdlchar">=</span><span class="vhdlchar">&gt;</span> <span class="vhdlchar">REG_STATE</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">REG_STATE_IDLE</span>;</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;      <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">case</span>;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">if</span>;</div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">process</span> <span class="vhdlchar">register_control</span>;</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;<span class="keyword">  --Wired up address <span class="vhdlkeyword">and</span> data signals directly <span class="vhdlkeyword">to</span> fifos instead <span class="vhdlkeyword">of</span> registering</span><span class="keyword"></span></div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;<span class="keyword">  --them <span class="vhdlkeyword">in</span> the register_control <span class="vhdlkeyword">process</span></span></div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;  <span class="vhdlchar">read_cycle_address_fifo_in</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">RD_address</span>;</div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;  <span class="vhdlchar">write_cycle_addr_and_data</span>  <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">WR_address</span> <span class="vhdlchar">&amp;</span> <span class="vhdlchar">data_in</span>;</div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;<span class="keyword"></span></div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;<span class="keyword">  --All the fifos needed <span class="vhdlkeyword">for</span> reads <span class="vhdlkeyword">and</span> writes</span></div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;  <span class="vhdlchar">read_fifos</span> <span class="vhdlchar">:</span> <span class="vhdlkeyword">for</span> <span class="vhdlchar">iClockDomain</span> <span class="vhdlkeyword">in</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span> <span class="vhdlkeyword">to</span> <span class="vhdlchar">CLOCK_DOMAINS</span><span class="vhdlchar">-</span><span class="vhdllogic"></span><span class="vhdllogic">1</span> <span class="vhdlkeyword">generate</span></div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    IOREG_FIFO_1 : <span class="vhdlkeyword">entity</span> work.<a class="code" href="classIOREG__READ__ADDR__FIFO.html">IOREG_READ_ADDR_FIFO</a></div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;      <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        data     =&gt; read_cycle_address_fifo_in ,<span class="keyword">           --clk_reg_map domain</span></div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        rdclk    =&gt; clk_domain<span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;        rdreq    =&gt; read_address_ack <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        wrclk    =&gt; clk_reg_map ,</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        wrreq    =&gt; read_cycle_address_wr <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,<span class="keyword">  --clk_reg_map domain</span></div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        q        =&gt; read_address <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        rdempty  =&gt; read_address_fifo_empty <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    <span class="vhdlchar">read_address_valid</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlkeyword">not</span> <span class="vhdlchar">read_address_fifo_empty</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    IOREG_READ_DATA_FIFO_1 : <span class="vhdlkeyword">entity</span> work.<a class="code" href="classIOREG__READ__DATA__FIFO.html">IOREG_READ_DATA_FIFO</a></div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;      <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        aclr     =&gt; read_cycle_data_fifo_reset <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,<span class="keyword">  --clk_reg_map domain</span></div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        data     =&gt; read_data<span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        rdclk    =&gt; clk_reg_map ,</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        rdreq    =&gt; read_cycle_data_ack <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,<span class="keyword">     --clk_reg_map domain</span></div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        wrclk    =&gt; clk_domain<span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        wrreq    =&gt; read_data_wr <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;        q        =&gt; read_cycle_data_fifo_out <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,<span class="keyword">  --clk_reg_map domain</span></div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        rdempty  =&gt; read_cycle_data_empty <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span><span class="vhdlchar">)</span>;<span class="keyword">  --clk_reg_map domain</span></div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <span class="vhdlchar">read_data_fifo_found</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">read_cycle_data_fifo_out</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">32</span><span class="vhdlchar">)</span>;<span class="keyword">  --clk_reg_map domain</span></div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    IOREG_WRITE_FIFO_1 : <span class="vhdlkeyword">entity</span> work.<a class="code" href="classIOREG__WRITE__FIFO.html">IOREG_WRITE_FIFO</a></div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;      <span class="vhdlkeyword">port</span> <span class="vhdlkeyword">map</span> (</div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;        data     =&gt; write_cycle_addr_and_data ,<span class="keyword">             --clk_reg_map domain</span></div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;        rdclk    =&gt; clk_domain<span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;        rdreq    =&gt; write_addr_data_ack <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;        wrclk    =&gt; clk_reg_map ,</div>
<div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;        wrreq    =&gt; write_cycle_addr_data_wr <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,<span class="keyword">              --clk_reg_map domain</span></div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;        q        =&gt; write_addr_data <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span>,</div>
<div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;        rdempty  =&gt; write_fifo_empty <span class="vhdlchar">(</span>iClockDomain<span class="vhdlchar">)</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <span class="vhdlchar">write_addr_data_valid</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span> <span class="vhdlchar">&lt;=</span> <span class="vhdlkeyword">not</span> <span class="vhdlchar">write_fifo_empty</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span>;</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    <span class="vhdlchar">write_addr</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span>            <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">write_addr_data</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">47</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">32</span><span class="vhdlchar">)</span>;<span class="keyword">  --clk_reg_map domain</span></div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <span class="vhdlchar">write_data</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span>            <span class="vhdlchar">&lt;=</span> <span class="vhdlchar">write_addr_data</span><span class="vhdlchar">(</span><span class="vhdlchar">iClockDomain</span><span class="vhdlchar">)</span><span class="vhdlchar">(</span><span class="vhdllogic"></span><span class="vhdllogic">31</span> <span class="vhdlkeyword">downto</span> <span class="vhdllogic"></span><span class="vhdllogic">0</span><span class="vhdlchar">)</span>;<span class="keyword">  --clk_reg_map domain</span></div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;  <span class="vhdlkeyword">end</span> <span class="vhdlkeyword">generate</span> <span class="vhdlchar">read_fifos</span>;</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;<span class="vhdlkeyword">end</span> <span class="vhdlkeyword">architecture</span> <span class="vhdlchar">Behavioral</span>;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Wed Nov 1 2017 10:40:31 for DUNE Warm Interface Board by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.1
</small></address>
</body>
</html>
